@echo off

setlocal

set CURDIR=%CD%
set BINDIR=%~dp0

cd /d %BINDIR%\..
call .\setupCmdLine.bat

cd /d %BINDIR%\..\..
SET WAS_HOME=%cd%

cd /d %BINDIR%
set PMT_ECLIPSE_DIR=eclipse%COMMAND_SDK:~-2%


set Trace = ""
set TraceFile = ""
set argC=0

if "%1" == "" goto start

for %%x in (%*) do Set /A argC+=1

if not "%1" == "" goto verifyTrace

:verifyTrace
if "%1" == "-trace" goto setupTrace
if "%1" == "-traceFile" goto setupTraceFile
goto Error

:setupTrace
     REM echo %Trace% %TraceFile%
     if "%2" == "" goto ErrorParamTraceMissing
     if not "%3" == "-traceFile" goto ErrorParamTraceFileMissing
     if not %argC% == 4 goto ErrorParamTraceFileMissing
     if "%2" =="fine" goto proceed
     if "%2" =="finer" goto proceed
     if "%2" =="finest" goto proceed
     if "%2" =="all" goto proceed
     if "%2" =="FINE" goto proceed
     if "%2" =="FINER" goto proceed
     if "%2" =="FINEST" goto proceed
     if "%2" =="ALL" goto proceed
     goto InvalidParamSecond

:setupTraceFile
     if %argC% == 1 goto ErrorParamTraceFileMissing
     if not "%3" == "-trace" goto ErrorParamTraceMissing
     if not %argC% == 4 goto ErrorParamTraceMissing
     if "%4" =="fine" goto proceed
     if "%4" =="finer" goto proceed
     if "%4" =="finest" goto proceed
     if "%4" =="all" goto proceed
     if "%4" =="FINE" goto proceed
     if "%4" =="FINER" goto proceed
     if "%4" =="FINEST" goto proceed
     if "%4" =="ALL" goto proceed
     goto InvalidParamFourth

:proceed
REM echo Starting migration wizard with params %*

:start
REM set argC=0
REM for %%x in (%*) do Set /A argC+=1
REM echo argC - %argC%

if "%1" == "-trace" set launchargs=-vm "%WAS_HOME%\java\jre\bin\javaw.exe" %* -configuration "%WAS_HOME%\bin\bpm_migration\configuration" -vmargs -Xbootclasspath/a:"%WAS_HOME%\lib\bootstrap.jar" -Djava.endorsed.dirs="%WAS_HOME%\endorsed_apis":"%WAS_HOME%\jre\lib\endorsed" -Declipse.refreshBundles=true -DJAVA_NATIVE_LIB_DIR="%JAVA_NATIVE_LIB_DIR%" -DWAS_HOME="%WAS_HOME%" -DSystemRoot=%SystemRoot% -Dwas.install.root="%WAS_HOME%" -Dtrace=%2 -DtraceFile=%4
if "%1" == "-traceFile" set launchargs=-vm "%WAS_HOME%\java\jre\bin\javaw.exe" %* -configuration "%WAS_HOME%\bin\bpm_migration\configuration" -vmargs -Xbootclasspath/a:"%WAS_HOME%\lib\bootstrap.jar" -Djava.endorsed.dirs="%WAS_HOME%\endorsed_apis":"%WAS_HOME%\jre\lib\endorsed" -Declipse.refreshBundles=true -DJAVA_NATIVE_LIB_DIR="%JAVA_NATIVE_LIB_DIR%" -DWAS_HOME="%WAS_HOME%" -DSystemRoot=%SystemRoot% -Dwas.install.root="%WAS_HOME%" -DtraceFile=%2 -Dtrace=%4
if "%1" == "" set launchargs=-vm "%WAS_HOME%\java\jre\bin\javaw.exe" %* -configuration "%WAS_HOME%\bin\bpm_migration\configuration" -vmargs -Xbootclasspath/a:"%WAS_HOME%\lib\bootstrap.jar" -Djava.endorsed.dirs="%WAS_HOME%\endorsed_apis":"%WAS_HOME%\jre\lib\endorsed" -Declipse.refreshBundles=true -DJAVA_NATIVE_LIB_DIR="%JAVA_NATIVE_LIB_DIR%" -DWAS_HOME="%WAS_HOME%" -DSystemRoot=%SystemRoot% -Dwas.install.root="%WAS_HOME%"

REM echo "migration" "Migration" %launchargs%
start "migration" "%WAS_HOME%\bin\ProfileManagement\%PMT_ECLIPSE_DIR%\eclipse.exe" %launchargs%
endlocal
goto end

:Error
echo Invalid parameters passed for BPMMigrate
goto usage

:ErrorParamTrace
echo Invalid value passed for -trace parameter using BPMMigrate
goto usage

:ErrorParamTraceMissing
echo Value missing for parameter -trace using BPMMigrate
goto usage

:ErrorParamTraceFile
echo Invalid value passed for -traceFile parameter using BPMMigrate
goto usage

:ErrorParamTraceFileMissing
echo Value missing for parameter -traceFile using BPMMigrate
goto usage

:InvalidParamSecond
echo Invalid value %2 passed for parameter %1 using BPMMigrate
goto usage

:InvalidParamFourth
echo Invalid value %4 passed for parameter %3 using BPMMigrate
goto usage

:usage
echo Usage: BPMMigrate [options]
echo where possible options can be:
echo "-trace <fine|finer|finest|all>"
echo "-traceFile <trace file name>"
echo e.g. "BPMMigrate -trace fine -traceFile C:\backup\logs\BPMMigrate.trace"

:end